
* ---------------------------------------------------------------- smcaddeq
       Program smcaddeq

* Reads earthquake name from control file and writes in text header(4)(27:80).

* For flexibility, information is read from a control file.
* Here is an example:
*Control file for program SMC_Add
*Earthquake Name (<= 54 characters, but try to make it <=19 to for SMC_INFO)
* 1992 Cape Mendo MS
*Name of SMC file, followed by station name:
*319A.SMC
*319B.SMC
*319C.SMC
*334A.SMC
*334B.SMC
*334C.SMC
*stop

*  Dates:  03/21/01 - Written by D. Boore (based on SMC_Add.FOR)
*          07/17/03 - Add sps parameter to smc_npts
*        10/17/07 - Transparent change to user needed because smcread can
*                   read two input formats

      character precision*8


      real  rhead(50)

      integer ihead(48)

      real y(:)
      allocatable :: y

      character chead(11)*80, comments(200)*80, eqname*54
      character f_ctl*40, f_in*70, f_out*70, f_smc*40
      character buf_stop*4, date_c*8, time_c*11

      logical f_ctl_exist

* Open Input file:

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl, status='unknown')


      call skip(nu_ctl,2)
      eqname = ' '
      read(nu_ctl,'(a)') eqname
      call trim_c(eqname,nc_eqname)

      call skip(nu_ctl,1)

1000  continue

      f_smc = ' '
      read(nu_ctl,'(a)') f_smc
      call trim_c(f_smc,nc_f_smc)
      buf_stop = ' '
      buf_stop = f_smc(1:4)
      call upstr(buf_stop)

      if(buf_stop .eq. 'STOP') then
        close(nu_ctl)
        stop
      end if

      f_in = ' '
      f_in = f_smc(1:nc_f_smc)

      f_out = ' '
      f_out = f_smc(1:nc_f_smc)

* DEBUG
      write(*,'(2a)') ' f_in = ', f_in
      write(*,'(2a)') ' f_out = ', f_out
* DEBUG

      call smc_npts(f_in,npts_smc,sps)
      allocate(y(npts_smc))

      tskip = 0.0
      tlength = 9999.9
      call SMCRead(f_in, tskip, tlength,
     :                   y, chead, ihead, rhead, comments)

      chead(4)(27:80) = ' '
      chead(4)(27:27+nc_eqname-1) = eqname

      iflag = 0 ! not used by current PC version of datetime; Chris
                ! Stephens would modify datetime.for to include Unix routines
      call datetime(date_c, time_c, iflag)
      ncomments = ihead(16)
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ncomments = ncomments + 1
      comments(ncomments) = '| Using program smcaddeq:'
      ncomments = ncomments + 1
      comments(ncomments) = 
     :  '|   Earthquake name added to text header on '//date_c//
     :  ' at time '//time_c
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      ihead(16) = ncomments

      precision = 'STANDARD'
      itype = -1
      call SMCWrite(f_out, precision,
     :                y, chead, itype, 
     :                 ihead, rhead, comments)

* That should be it; deallocate the y array and loop back for another file
 
      deallocate(y)

      goto 1000

      end
* ---------------------------------------------------------------- smcaddeq


      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\smcread.for'
      include '\forprogs\smcwrite.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\mnmax.for'
      include '\forprogs\mnmaxidx.for'
      include '\forprogs\smc_npts.for'
      include '\forprogs\datetime.for'

                     