      Program split_smc2psa_rot_gmrot_output

! NOTE: This program works with the output of SMC2PSA_Rot_GMRot_interp_acc_Rot_Osc_TS

*!Control file for program split_smc2psa_rot_gmrot_output
*! Revision of program involving a change in the control file on this date:
*   05/15/13
*!Summary file name:
* split_smc2psa_rot_gmrot_output.sum
*!Number of periods (not including pga, pgv, pgd):
* 111
*!List of smc2psa_rot_gmrot_interp_acc_rot_osc_ts output file names 
*smc2psa_rot_gmrot.azm120_30.test3.test_file_azm_30.smc.damp0.01.out
*smc2psa_rot_gmrot.azm120_30.test3.test_file_azm_30.smc.damp0.02.out
*smc2psa_rot_gmrot.azm120_30.test3.test_file_azm_30.smc.damp0.05.out
*smc2psa_rot_gmrot.azm120_30.test3.test_file_azm_30.smc.damp0.10.out
*smc2psa_rot_gmrot.azm120_30.test3.test_file_azm_30.smc.damp0.20.out
*  StoP
      
      
! Dates: 05/15/13 - Written by D. Boore
!        05/19/13 - Corrected bug found by Andreas Skarlatoudis in 
!                   reading pga_rot100, pgv_rot100, pgd_rot100
!        01/27/18 - Allow for recent addition of rot50ang to output of 
!                   SMC2PSA_Rot_GMRot_interp_acc_Rot_Osc_TS
!        02/03/18 - Allow for two rotd50 angles (on either side of the mean)
!                   in the input file.

!      implicit none

      character cmnts2skip(200)*80   
      character buf*200, buf4*10, f_ctl*300, f_sum*300,
     :  f_in*300, f_out_d50*300, f_out_d100*300,
     :  colhead_per(120)*9, f_smc1*70, f_smc2*70,
     :  units_acc_vel_c*8
     
      real rotd50(120), rotd100(120), log10npts1, log10npts2
     
      integer nc_f_ctl, nc_buf, nc_f_sum, nc_comments,
     :  nc_f_in, nc_f_out_d50, nc_f_out_d100, nperiods,
     :  npts1, npts2
      
      integer ios, index_last_period, nu_ctl, 
     :  nu_in, nu_out_d50, nu_out_d100
       
      character version_ctl*8, version_in*30

      logical f_exist

      f_exist = .false.
      DO while (.not. f_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file '//
     :    '(cr = split_smc2psa_rot_gmrot_output.ctl): '
        read(*, '(a)') f_ctl
        IF (f_ctl == ' ') f_ctl = 'split_smc2psa_rot_gmrot_output.ctl'
        call trim_c(f_ctl,nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_exist)
        IF (.not. f_exist) THEN
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        END IF
      END DO

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')

*Check version of control file
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      version_in = ' '
      read(nu_ctl,'(a)') version_in
      call trim_c(version_in,nc_version_in)
      
      version_ctl = ' '
      version_ctl = '05/15/13'
      call trim_c(version_ctl,nc_version_ctl)

      IF (version_ctl(1:nc_version_ctl) /= 
     :    version_in(1:nc_version_in)) THEN
        write(*,'(a)') 
     :     ' The control file has the wrong version date; STOP!'
        close(nu_ctl)
        stop
      END IF
      
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      f_sum = ' '
      read(nu_ctl,'(a)') f_sum
      call get_lun(nu_sum)
      call trim_c(f_sum,nc_f_sum)
      open(unit=nu_sum,file=f_sum(1:nc_f_sum),status='unknown')    
      write(nu_sum,'(a)') ' Summary file for program NGA2PSA_Rot_GMRot'
      write(nu_sum,'(2a)') '   Using control file: ', f_ctl
      DO i = 1, nc_comments
        write(nu_sum,'(a)') cmnts2skip(i)
      END DO
      write(nu_sum,'(a)') f_sum

      call skipcmnt(nu_ctl,cmnts2skip,nc_comments)
      DO i = 1, nc_comments
        write(nu_sum,'(a)') cmnts2skip(i)
      END DO
      read(nu_ctl,*) nperiods
      write(nu_sum,'(1x,a, 1x,i4)') ' nperiods = ', nperiods
      
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      DO i = 1, nc_comments
        write(nu_sum,'(1x,a)') cmnts2skip(i)(1:79)
      END DO


      BIG LOOP OVER INPUT FILES: DO

        write(nu_sum,*)

        buf = ' '
        read(nu_ctl,'(a)',iostat=ios) buf
        print *,' buf = '//buf
        
        if (ios /= 0) then  ! reached end of file
          EXIT BIG LOOP OVER INPUT FILES
        end if
        
        call trim_c(buf,nc_buf)
        print *,' buf = '//buf(1:nc_buf)
        buf4 = ' '
        buf4 = buf(1:4)
        call upstr(buf4)

        IF (buf4(1:4) == 'STOP') THEN
          write(*, '(a)') 
     :           ' buf = '//buf(1:nc_buf)//'; QUITTING' 
          EXIT BIG LOOP OVER INPUT FILES
        END IF  ! terminate on reaching "STOP"

        f_in = ' '
        f_in = buf(1:nc_buf)
        call trim_c(f_in, nc_f_in)
        f_exist = .false.
        INQUIRE(file=f_in(1:nc_f_in), exist=f_exist)
        IF (.not. f_exist) THEN
          write(nu_sum,'(a)') ' ******* FILE '//
     :                         f_in(1:nc_f_in)//
     :                        ' DOES NOT EXIST: CYCLE! ******* '
            CYCLE BIG LOOP OVER INPUT FILES
        END IF
        
        write(nu_sum,'(a,i1,a)') 
     :                 ' f_in = '//f_in(1:nc_f_in)
        write(*,'(a,i1,a)') 
     :                 ' f_in = '//f_in(1:nc_f_in)

! Get columns headers for periods:
        call get_lun(nu_in)
        open(unit=nu_in,file=f_in(1:nc_f_in),
     :       status='unknown') 

        call skipcmnt(nu_in,cmnts2skip, nc_comments)
        colhead_per = ' '     
        read(nu_in,'(t755,120(a9,195x))') 
     :    (colhead_per(i), i=1, nperiods)
        close(nu_in)
!DEBUG
        do i=1, nperiods
          write(nu_sum,'(1x,i3, 1x,a)') i, colhead_per(i)
        end do
!DEBUG
        
!Create output files, write headers:

! find index of last period in filename, strip off extension

        index_last_period = IndxLast(f_in(1:nc_f_in), '.')
        
        f_out_d50 = ' '
        f_out_d50 = f_in(1:index_last_period)//'d50.out'
        call get_lun(nu_out_d50)
        call trim_c(f_out_d50,nc_f_out_d50)
        open(unit=nu_out_d50,file=f_out_d50(1:nc_f_out_d50),
     :       status='unknown')    
        write(nu_sum,'(a)') 
     :     ' Output file for D50:'//f_out_d50(1:nc_f_out_d50)
        
        f_out_d100 = ' '
        f_out_d100 = f_in(1:index_last_period)//'d100.out'
        call get_lun(nu_out_d100)
        call trim_c(f_out_d100,nc_f_out_d100)
        open(unit=nu_out_d100,file=f_out_d100(1:nc_f_out_d100),
     :       status='unknown')    
        write(nu_sum,'(a)') 
     :     ' Output file for D100:'//f_out_d100(1:nc_f_out_d100)
        
          
        write(nu_out_d50,'(
     :      65x,a,
     :      1x, 65x,a,
     :      3x,a, 1x,a,
     :      3x,a, 1x,a,
     :      1x,a,
     :      3x,a,
     :      3x,a,  
     :      3x,a,
     :   200(3x,a9)
     :                             )') 
     :     'file1', 
     :     'file2',
     :     'flc1', 'nslope1',
     :     'flc2', 'nslope2',
     :     'units_acc_vel',
     :     'pga_rot50',
     :     'pgv_rot50',  
     :     'pgd_rot50',  
     :     (colhead_per(iper), iper = 1, nperiods)

        write(nu_out_d100,'(
     :      65x,a,
     :      1x, 65x,a,
     :      3x,a, 1x,a,
     :      3x,a, 1x,a,
     :      1x,a,
     :      2x,a,
     :      2x,a,  
     :      2x,a,
     :   200(3x,a9)
     :                             )') 
     :     'file1', 
     :     'file2',
     :     'flc1', 'nslope1',
     :     'flc2', 'nslope2',
     :     'units_acc_vel',
     :     'pga_rot100',
     :     'pgv_rot100',  
     :     'pgd_rot100',  
     :     (colhead_per(iper), iper = 1, nperiods)

! Open file, extract desired columns:

        call get_lun(nu_in)
        open(unit=nu_in,file=f_in(1:nu_in),
     :       status='unknown') 

        call skipcmnt(nu_in,cmnts2skip, nc_comments)

        call skip(nu_in,1)
        
        DO 
        
! read a line, extract desired quantities, write to the files 

!old
!     :      t474,es11.4, t486,es11.4,
!     :      t536,es11.4, t548,es11.4,
!     :      t598,es11.4, t610,es11.4,

          read(nu_in,'(
     :      a70, 
     :      1x,a70, 
     :      1x,f10.5, 1x,f10.5,
     :      1x,f6.3, 5x,i3,
     :      1x,f6.3, 5x,i3,
     :      7x,f6.1,
     :      6x,a8,
     :      t497,es11.4, t510,es11.4,
     :      t585,es11.4, t598,es11.4,
     :      t673,es11.4, t686,es11.4,
     :      t889,120(1x,es12.6, 1x,es12.6, 178x)
     :                                 )',iostat=ios) 
     :      f_smc1, 
     :      f_smc2, 
     :      log10npts1, log10npts2,
     :      flc1, nslope1,
     :      flc2, nslope2,
     :      tmax4penalty,
     :      units_acc_vel_c,
     :      pga_rot50, pga_rot100,
     :      pgv_rot50, pgv_rot100,
     :      pgd_rot50, pgd_rot100,
     :      (rotd50(i), rotd100(i), i = 1, nperiods)
     
            npts1 = int(10**log10npts1)
            npts2 = int(10**log10npts2)
     
          IF (ios /= 0) THEN
            print *, ' Reached the end of file '//f_in(1:nc_f_in)
            close(nu_in)
            EXIT
          END IF
          
          call trim_c(f_smc1, nc_f_smc1)
          call trim_c(f_smc2, nc_f_smc2)
          call trim_c(units_acc_vel_c, nc_units_acc_vel_c)
     
          write(nu_out_d50,'(
     :      a70, 
     :      1x,a70, 
     :      1x,f6.3, 5x,i3,
     :      1x,f6.3, 5x,i3,
     :      6x,a8,
     :      1x,es11.5,  
     :      1x,es11.5,  
     :      1x,es11.5,  
     :      120(1x,es11.5) 
     :                                 )' ) 
     :      f_smc1(1:nc_f_smc1), 
     :      f_smc2(1:nc_f_smc2), 
     :      flc1, nslope1,
     :      flc2, nslope2,
     :      units_acc_vel_c(1:nc_units_acc_vel_c),
     :      pga_rot50, 
     :      pgv_rot50,  
     :      pgd_rot50, 
     :      (rotd50(i), i = 1, nperiods)
     
          write(nu_out_d100,'(
     :      a70, 
     :      1x,a70, 
     :      1x,f6.3, 5x,i3,
     :      1x,f6.3, 5x,i3,
     :      6x,a8,
     :      1x,es11.5,  
     :      1x,es11.5,  
     :      1x,es11.5,  
     :      120(1x,es11.5) 
     :                                 )' ) 
     :      f_smc1(1:nc_f_smc1), 
     :      f_smc2(1:nc_f_smc2), 
     :      flc1, nslope1,
     :      flc2, nslope2,
     :      units_acc_vel_c(1:nc_units_acc_vel_c),
     :      pga_rot100, 
     :      pgv_rot100,  
     :      pgd_rot100, 
     :      (rotd100(i), i = 1, nperiods)
     
        END DO
        
        close(nu_out_d50)
        close(nu_out_d100)
        
      END DO BIG LOOP OVER INPUT FILES
      
      close(nu_ctl)
      
      END
      
      include '\forprogs\get_lun.for'     
      include '\forprogs\skip.for'     
      include '\forprogs\trim_c.for'     
      include '\forprogs\upstr.for'     
      include '\forprogs\skipcmnt.for'     
      include '\forprogs\indxlast.for'     

       