      Program transpose_smc2rs_output
      
* Transpose smc2rs output files so can more easily import
* into AB06 e-supplement Excel format.

*!Control file for transposing smc2rs output files so can more easily import
*! into AB06 e-supplement Excel format.
*! Revision of program involving a change in the control file on this date:
*   07/03/09
*!
*!The output will be pairs of lines according to the column selections 
*!specified below.
*!first line (1=period, 2=frequency):
* 2
*!second line (3=sd, 4=pv, 5=pa, 6=rv, 7=aa)
* 5
*!Output file name
* ausable_transpose_rs.out
*!smc2rs files to transpose
*GAC.V01.A5.rs.tab_per.col
*GAC.V03.A5.rs.tab_per.col
*HRVCL.V01.A5.rs.tab_per.col
*HRVCL.V03.A5.rs.tab_per.col
*MNT.V01.A5.rs.tab_per.col
*MNT.V03.A5.rs.tab_per.col
*stop

* Dates: 07/03/09 - Written by D. Boore

      implicit none

      real dum(7), x(300), y(300)
      integer status, col4line1, col4line2, i
      integer :: nx, char_out
      integer :: nc_f_ctl, nc_f_out, nc_f_in
      integer :: nc_version_ctl, nc_cmnts2skip, nc_version_in, nc_buf
      integer :: nu_ctl, nu_out, nu_in
      
      

      character comments(200)*80, buf*100, buf4*4, buf40*40
      character cmnts2skip(20)*80
      character f_ctl*120, f_in*120, f_out*120, 
     :          version_ctl*8, version_in*30

      logical :: f_exist=.false. 

      version_ctl = ' '
      version_ctl = '07/03/09'
      call trim_c(version_ctl,nc_version_ctl)

!      f_exist = .false.
      do while (.not. f_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file '//
     :    '(cr = transpose_smc2rs_output.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'transpose_smc2rs_output.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_exist)
        if (.not. f_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='old',
     :     iostat=status)

      if (status /= 0) then
        write(*,'(a, i2, a)') ' error opening file, iostat = ', 
     :                        status, '; STOP!'
        stop
      end if
      
      call skipcmnt(nu_ctl, cmnts2skip, nc_cmnts2skip)
      version_in = ' '
      read(nu_ctl,'(a)') version_in
      call trim_c(version_in,nc_version_in)
      
      if (version_ctl(1:nc_version_ctl) .ne. 
     :    version_in(1:nc_version_in)) then
        write(*,'(a)') 
     :     ' The control file has the wrong version number; STOP!'
        close(nu_ctl)
        stop
      end if
      
      call skipcmnt(nu_ctl, cmnts2skip, nc_cmnts2skip)
      read(nu_ctl,*) col4line1
      
      call skipcmnt(nu_ctl, cmnts2skip, nc_cmnts2skip)
      read(nu_ctl,*) col4line2
      
      call skipcmnt(nu_ctl, cmnts2skip, nc_cmnts2skip)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out, nc_f_out)
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out(1:nc_f_out),status='unknown')
      
      call skipcmnt(nu_ctl, cmnts2skip, nc_cmnts2skip)
      
      readfilesloop: do

        buf = ' '
        read(nu_ctl,'(a)') buf
        call trim_c(buf,nc_buf)
        buf4 = ' '
        buf4 = buf(1:4)
        call upstr(buf4)
        if (buf4 .eq. 'STOP') exit

        f_in = ' '
        f_in = buf(1:nc_buf)
        call trim_c(f_in, nc_f_in)

        f_exist = .false.
        inquire(file=f_in(1:nc_f_in), exist=f_exist)
        if (.not. f_exist) then
          write(*,'(a)') ' ** Input file '//f_in(1:nc_f_in)//
     :    ' does not exist, STOP!'
          exit
        end if

        write(*,'(a)') ' Processing file: '//f_in(1:nc_f_in)
        call get_lun(nu_in)
        open(unit=nu_in,file=f_in(1:nc_f_in),status='unknown')
        call skip(nu_in,1)
        
        nx = 0
        x = 0.0
        y = 0.0
        
        readrsloop: do
        
          read(nu_in,*,iostat=status) (dum(i),i=1,col4line2)
          if( status /= 0) exit  ! finished with this file
          nx = nx + 1
          x(nx) = dum(col4line1)
          y(nx) = dum(col4line2)
          
        end do readrsloop
        
        close(nu_in)
        
! print line 1 and line 2

        char_out = min(40, nc_f_in)
        buf40 = ' '
        buf40(40-char_out+1: 40) = f_in(1:char_out)

        write(nu_out,'(a42, 1p, 300(1x,e12.5))')
     :  buf40//':x',
     :  (x(i), i=1, nx)
     
        write(nu_out,'(a42, 1p, 300(1x,e12.5))')
     :  buf40//':y',
     :  (y(i), i=1, nx)
     
! finished with this file, loop back for another one.     

      end do  readfilesloop 
      
      close(nu_ctl)
      close(nu_out)

      end
      
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\skipcmnt.for'
      
      

